test_that("Test analyse_hydraulic",
    {
        output_dir = tempdir()

        model = analyse_model(
            model = "adu_t",
            type = "adu",
            path = init_create_path(
                input = system.file(
                    "extdata", 
                    package = "floodam.building"
                ),
                output = output_dir
            ),
            stage = c("load", "extract", "hydraulic"),
            verbose = FALSE
        )

        flood = generate_limnigraph(
            time = c(0, 54, 108),
            depth = cbind(external_1 = c(0, 3, 0), external_2 = c(0, 0, 0)),
            external = list(
                external_1 = c("door1", "window1", "window2"),
                external_2 = c("window3"))
        )

        expect_no_error(analyse_hydraulic(
            model = model,
            limnigraph = flood,
            opening_scenario = "close",
            dt_max = 0.5,
            Cd = 0.42,
            sim_id = "integrated_model"))
    }
)
