test_that("Test generate_limnigraph",
    {
        # Simple
        l_0 = expect_no_error(
            generate_limnigraph(
                time = c(0, 1000, 2000),
                depth = c(0, 1, 0),
                external = "door"
            )
        )

        # Simple more verbose
        l_1 = expect_no_error(
            generate_limnigraph(
                time = c(0, 1000, 2000),
                depth = c(0, 1, 0),
                external = list(external = "door")
            )
        )

        expect_identical(l_0, l_1)

        # Complex
        l = expect_no_error(
            generate_limnigraph(
                time = c(0, 54, 108),
                depth = cbind(external_1 = c(0, 3, 0), external_2 = c(0, 0, 0)),
                external = list(
                    external_1 = c("door"),
                    external_2 = c("window"))
            )
        )

        # Errors handling
        expect_error(
            generate_limnigraph(
                time = c(0, 1000),
                depth = c(0, 1, 0),
                external = "door",
                verbose = FALSE
            ),
            "'time' and 'depth' do not have compatible lengths."
        )

        expect_error(
            generate_limnigraph(
                time = c(0, 1000, 2000),
                depth = c(0, 1, 0),
                external = list(ext = "door"),
                verbose = FALSE
            ),
            "'depth' and 'external' names must be matching"
        )
    }
)
